/**
 * NetworkSetting.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Mar 02, 2009 (07:08:06 PST) WSDL2Java emitter.
 */

package com.google.api.ads.adwords.axis.v201206.cm;


/**
 * Network settings for a Campaign.
 *             <aside class="note"><b>Note:</b>
 *             Setting {@code targetContentContextual} for new campaigns
 * or
 *             existing campaigns that have enabled Flexible Reach
 *             ({@code TargetRestrictSetting.useAdGroup=true}) will fail
 * with
 *             {@code TargetError.CANNOT_MODIFY_CONTENT_CONTEXTUAL}.</aside>
 */
public class NetworkSetting  implements java.io.Serializable {
    /* Ads will be served with Google.com search results.
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetGoogleSearch".</span><span class="constraint
     * Filterable">This field can be filtered on.</span>
     *                 <span class="constraint AdxEnabled">This is disabled
     * for AdX.</span> */
    private java.lang.Boolean targetGoogleSearch;

    /* Ads will be served on partner sites in the Google Search Network
     * (requires {@code GOOGLE_SEARCH}).
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetSearchNetwork".</span><span class="constraint
     * Filterable">This field can be filtered on.</span>
     *                 <span class="constraint AdxEnabled">This is disabled
     * for AdX.</span> */
    private java.lang.Boolean targetSearchNetwork;

    /* Ads will be served on specified placements in the Google Display
     * Network.
     *                 Placements are specified using {@code Placement} criteria.
     * <span class="constraint Selectable">This field can be selected using
     * the value "TargetContentNetwork".</span><span class="constraint Filterable">This
     * field can be filtered on.</span> */
    private java.lang.Boolean targetContentNetwork;

    /* Ads will be served on the Google Display Network based on
     *                 {@code Keyword} criteria contextually matching the
     * placement's content
     *                 (requires {@code CONTENT_NETWORK}).
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetContentContextual".</span><span
     * class="constraint Filterable">This field can be filtered on.</span>
     * <span class="constraint AdxEnabled">This is disabled for AdX.</span> */
    private java.lang.Boolean targetContentContextual;

    /* Ads will be served on the Google Partner Network. This is available
     * to
     *                 only some specific Google partner accounts.
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetPartnerSearchNetwork".</span><span
     * class="constraint Filterable">This field can be filtered on.</span>
     * <span class="constraint AdxEnabled">This is disabled for AdX.</span> */
    private java.lang.Boolean targetPartnerSearchNetwork;

    public NetworkSetting() {
    }

    public NetworkSetting(
           java.lang.Boolean targetGoogleSearch,
           java.lang.Boolean targetSearchNetwork,
           java.lang.Boolean targetContentNetwork,
           java.lang.Boolean targetContentContextual,
           java.lang.Boolean targetPartnerSearchNetwork) {
           this.targetGoogleSearch = targetGoogleSearch;
           this.targetSearchNetwork = targetSearchNetwork;
           this.targetContentNetwork = targetContentNetwork;
           this.targetContentContextual = targetContentContextual;
           this.targetPartnerSearchNetwork = targetPartnerSearchNetwork;
    }


    /**
     * Gets the targetGoogleSearch value for this NetworkSetting.
     * 
     * @return targetGoogleSearch   * Ads will be served with Google.com search results.
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetGoogleSearch".</span><span class="constraint
     * Filterable">This field can be filtered on.</span>
     *                 <span class="constraint AdxEnabled">This is disabled
     * for AdX.</span>
     */
    public java.lang.Boolean getTargetGoogleSearch() {
        return targetGoogleSearch;
    }


    /**
     * Sets the targetGoogleSearch value for this NetworkSetting.
     * 
     * @param targetGoogleSearch   * Ads will be served with Google.com search results.
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetGoogleSearch".</span><span class="constraint
     * Filterable">This field can be filtered on.</span>
     *                 <span class="constraint AdxEnabled">This is disabled
     * for AdX.</span>
     */
    public void setTargetGoogleSearch(java.lang.Boolean targetGoogleSearch) {
        this.targetGoogleSearch = targetGoogleSearch;
    }


    /**
     * Gets the targetSearchNetwork value for this NetworkSetting.
     * 
     * @return targetSearchNetwork   * Ads will be served on partner sites in the Google Search Network
     * (requires {@code GOOGLE_SEARCH}).
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetSearchNetwork".</span><span class="constraint
     * Filterable">This field can be filtered on.</span>
     *                 <span class="constraint AdxEnabled">This is disabled
     * for AdX.</span>
     */
    public java.lang.Boolean getTargetSearchNetwork() {
        return targetSearchNetwork;
    }


    /**
     * Sets the targetSearchNetwork value for this NetworkSetting.
     * 
     * @param targetSearchNetwork   * Ads will be served on partner sites in the Google Search Network
     * (requires {@code GOOGLE_SEARCH}).
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetSearchNetwork".</span><span class="constraint
     * Filterable">This field can be filtered on.</span>
     *                 <span class="constraint AdxEnabled">This is disabled
     * for AdX.</span>
     */
    public void setTargetSearchNetwork(java.lang.Boolean targetSearchNetwork) {
        this.targetSearchNetwork = targetSearchNetwork;
    }


    /**
     * Gets the targetContentNetwork value for this NetworkSetting.
     * 
     * @return targetContentNetwork   * Ads will be served on specified placements in the Google Display
     * Network.
     *                 Placements are specified using {@code Placement} criteria.
     * <span class="constraint Selectable">This field can be selected using
     * the value "TargetContentNetwork".</span><span class="constraint Filterable">This
     * field can be filtered on.</span>
     */
    public java.lang.Boolean getTargetContentNetwork() {
        return targetContentNetwork;
    }


    /**
     * Sets the targetContentNetwork value for this NetworkSetting.
     * 
     * @param targetContentNetwork   * Ads will be served on specified placements in the Google Display
     * Network.
     *                 Placements are specified using {@code Placement} criteria.
     * <span class="constraint Selectable">This field can be selected using
     * the value "TargetContentNetwork".</span><span class="constraint Filterable">This
     * field can be filtered on.</span>
     */
    public void setTargetContentNetwork(java.lang.Boolean targetContentNetwork) {
        this.targetContentNetwork = targetContentNetwork;
    }


    /**
     * Gets the targetContentContextual value for this NetworkSetting.
     * 
     * @return targetContentContextual   * Ads will be served on the Google Display Network based on
     *                 {@code Keyword} criteria contextually matching the
     * placement's content
     *                 (requires {@code CONTENT_NETWORK}).
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetContentContextual".</span><span
     * class="constraint Filterable">This field can be filtered on.</span>
     * <span class="constraint AdxEnabled">This is disabled for AdX.</span>
     */
    public java.lang.Boolean getTargetContentContextual() {
        return targetContentContextual;
    }


    /**
     * Sets the targetContentContextual value for this NetworkSetting.
     * 
     * @param targetContentContextual   * Ads will be served on the Google Display Network based on
     *                 {@code Keyword} criteria contextually matching the
     * placement's content
     *                 (requires {@code CONTENT_NETWORK}).
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetContentContextual".</span><span
     * class="constraint Filterable">This field can be filtered on.</span>
     * <span class="constraint AdxEnabled">This is disabled for AdX.</span>
     */
    public void setTargetContentContextual(java.lang.Boolean targetContentContextual) {
        this.targetContentContextual = targetContentContextual;
    }


    /**
     * Gets the targetPartnerSearchNetwork value for this NetworkSetting.
     * 
     * @return targetPartnerSearchNetwork   * Ads will be served on the Google Partner Network. This is available
     * to
     *                 only some specific Google partner accounts.
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetPartnerSearchNetwork".</span><span
     * class="constraint Filterable">This field can be filtered on.</span>
     * <span class="constraint AdxEnabled">This is disabled for AdX.</span>
     */
    public java.lang.Boolean getTargetPartnerSearchNetwork() {
        return targetPartnerSearchNetwork;
    }


    /**
     * Sets the targetPartnerSearchNetwork value for this NetworkSetting.
     * 
     * @param targetPartnerSearchNetwork   * Ads will be served on the Google Partner Network. This is available
     * to
     *                 only some specific Google partner accounts.
     *                 <span class="constraint Selectable">This field can
     * be selected using the value "TargetPartnerSearchNetwork".</span><span
     * class="constraint Filterable">This field can be filtered on.</span>
     * <span class="constraint AdxEnabled">This is disabled for AdX.</span>
     */
    public void setTargetPartnerSearchNetwork(java.lang.Boolean targetPartnerSearchNetwork) {
        this.targetPartnerSearchNetwork = targetPartnerSearchNetwork;
    }

    private java.lang.Object __equalsCalc = null;
    public synchronized boolean equals(java.lang.Object obj) {
        if (!(obj instanceof NetworkSetting)) return false;
        NetworkSetting other = (NetworkSetting) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.targetGoogleSearch==null && other.getTargetGoogleSearch()==null) || 
             (this.targetGoogleSearch!=null &&
              this.targetGoogleSearch.equals(other.getTargetGoogleSearch()))) &&
            ((this.targetSearchNetwork==null && other.getTargetSearchNetwork()==null) || 
             (this.targetSearchNetwork!=null &&
              this.targetSearchNetwork.equals(other.getTargetSearchNetwork()))) &&
            ((this.targetContentNetwork==null && other.getTargetContentNetwork()==null) || 
             (this.targetContentNetwork!=null &&
              this.targetContentNetwork.equals(other.getTargetContentNetwork()))) &&
            ((this.targetContentContextual==null && other.getTargetContentContextual()==null) || 
             (this.targetContentContextual!=null &&
              this.targetContentContextual.equals(other.getTargetContentContextual()))) &&
            ((this.targetPartnerSearchNetwork==null && other.getTargetPartnerSearchNetwork()==null) || 
             (this.targetPartnerSearchNetwork!=null &&
              this.targetPartnerSearchNetwork.equals(other.getTargetPartnerSearchNetwork())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getTargetGoogleSearch() != null) {
            _hashCode += getTargetGoogleSearch().hashCode();
        }
        if (getTargetSearchNetwork() != null) {
            _hashCode += getTargetSearchNetwork().hashCode();
        }
        if (getTargetContentNetwork() != null) {
            _hashCode += getTargetContentNetwork().hashCode();
        }
        if (getTargetContentContextual() != null) {
            _hashCode += getTargetContentContextual().hashCode();
        }
        if (getTargetPartnerSearchNetwork() != null) {
            _hashCode += getTargetPartnerSearchNetwork().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(NetworkSetting.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201206", "NetworkSetting"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetGoogleSearch");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201206", "targetGoogleSearch"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetSearchNetwork");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201206", "targetSearchNetwork"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetContentNetwork");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201206", "targetContentNetwork"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetContentContextual");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201206", "targetContentContextual"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetPartnerSearchNetwork");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/cm/v201206", "targetPartnerSearchNetwork"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
